/*
 * Generated by XDoclet - Do not edit!
 */
package hero.interfaces;

/**
 * Local interface for ProjectSession.
 * @copyright INRIA
 * @xdoclet-generated at ${TODAY}
 * @copyright The XDoclet Team
 * @author XDoclet
 * @version 3.1.3
 */
public interface ProjectSessionLocal
   extends javax.ejb.EJBLocalObject
{
   /**
    * Add a user to this project (This user must exist at bonita database)
    * @param userName The name of the user to associate to the project
    * @throws HeroException    */
   public void addUser( java.lang.String userName ) throws hero.util.HeroException;

   /**
    * Add a node to the project. This method creates a node with the corresponding node type and assign to it the hero.interfaces.Constants.InitialRole role.<br><br> Possible node types are:<br> <br> hero.interfaces.Constants.Nd.AND_JOIN_NODE // Manual and join node <br> hero.interfaces.Constants.Nd.OR_JOIN_NODE // Manual or join node <br> hero.interfaces.Constants.Nd.AND_JOIN_AUTOMATIC_NODE // Automatic and join node <br> hero.interfaces.Constants.Nd.OR_JOIN_AUTOMATIC_NODE // Automatic or join node <br>
    * @param name The name of the node to add to the project
    * @param nodeType The type of the node to add to the project
    * @throws HeroException    */
   public void addNode( java.lang.String name,int nodeType ) throws hero.util.HeroException;

   /**
    * Add a subProcess node to the project. This method creates the subProject from an existing project and creates the node associated to it. The type of created node is hero.interfaces.Constants.Nd.SUB_PROCESS_NODE
    * @param name The name of the node to add to the project
    * @param projectName the name of the subProcess
    * @throws HeroException    */
   public void addNodeSubProcess( java.lang.String name,java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Add a subProcess node to the project. This method creates the subProject from an existing project and creates the node associated to it. The type of created node is hero.interfaces.Constants.Nd.SUB_PROCESS_NODE
    * @param name The name of the node to add to the project
    * @param projectName the name of the subProcess
    * @param projectVersion the version of the subProcess
    * @throws HeroException    */
   public void addNodeSubProcess( java.lang.String name,java.lang.String projectName,java.lang.String projectVersion ) throws hero.util.HeroException;

   /**
    * Add an Agent to the Project
    * @param name The name of the Agent to add to the project
    * @throws HeroException    */
   public void addAgent( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Add an edge to the project. Creates a transition between two nodes by specifying the name of this edge. <strong> No more implemented </strong>
    * @param name the name ot the edge
    * @throws HeroException    */
   public void addEdge( java.lang.String name,java.lang.String in,java.lang.String out ) throws hero.util.HeroException;

   /**
    * Add an edge between two nodes of the project [in] ---- [out]. This operation refresh the out node state. If new edge forms a cycle an exception is throwed.
    * @param in the name of the in Node
    * @param out the name of the out Node
    * @throws HeroException    */
   public java.lang.String addEdge( java.lang.String in,java.lang.String out ) throws hero.util.HeroException;

   /**
    * Add an AgentEdge to the Project [in] ---- [out]
    * @param in the name of the in Agent
    * @param out the name of the out Node
    * @throws HeroException    */
   public java.lang.String addAgentEdge( java.lang.String in,java.lang.String out ) throws hero.util.HeroException;

   /**
    * Add a role to the project. Creates a role within this project. The role is specific of this project
    * @param name the name of the role
    * @param description the description of the role
    * @throws HeroException    */
   public void addRole( java.lang.String roleName,java.lang.String description ) throws hero.util.HeroException;

   /**
    * Add a new iteration between two nodes. This methods sets an iteration which is stopped when the lastNode property "iterate" is false.
    * @param from the name of the first node
    * @param to the name of the last node
    * @throws HeroException    */
   public void addIteration( java.lang.String from,java.lang.String to,java.lang.String condition ) throws hero.util.HeroException;

   /**
    * Internal method used in processes instantiation.
    * @param from
    * @param to
    * @param condition
    * @throws HeroException
    */
   public void copyIteration( java.lang.String from,java.lang.String to,java.lang.String condition ) throws hero.util.HeroException;

   /**
    * Delete an iteration between two nodes.
    * @param from the name of the first node
    * @param to the name of the last node
    * @throws HeroException    */
   public void deleteIteration( java.lang.String from,java.lang.String to ) throws hero.util.HeroException;

   /**
    * Add hook to project. Add an existing hook file to the project. This hook type uses a Java file loaded at run time. The hookName represents the class java file to be loaded by the system at run time. These classes must be in the application server classpath to be correctly executed.<br> The possible values of the argumets are:<br><br> <strong>eventName:<br></strong> hero.interfaces.Constants.Pj.ONINSTANTIATE<br><br> hero.interfaces.Constants.Pj.ONTERMINATE<br><br>
    * @param hookName the name of the hook
    * @param eventName the event
    * @param hookType the type
    * @throws HeroException    */
   public void addHook( java.lang.String hookName,java.lang.String eventName,int hookType ) throws hero.util.HeroException;

   /**
    * Add hook to a node. Add an existing hook file to the node. This type of hook use a Java file loaded at run time. The hookName represents the class java file to be loaded by the system at run time. These classes must be in the application server classpath to be correctly executed.<br> The possible values of the arguments are:<br><br> <strong>eventName:<br></strong> hero.interfaces.Constants.Nd.BEFORESTART<br> hero.interfaces.Constants.Nd.AFTERSTART<br> hero.interfaces.Constants.Nd.BEFORETERMINATE<br> hero.interfaces.Constants.Nd.AFTERTERMINATE<br> hero.interfaces.Constants.Nd.ONCANCEL<br> hero.interfaces.Constants.Nd.ANTICIPATE<br><br> hero.interfaces.Constants.Nd.ONDEADLINE<br><br> hero.interfaces.Constants.Nd.ONREADY<br><br> <br><br> <strong>hookType:<br></strong> hero.interfaces.Constants.Hook.JAVA<br><br> hero.interfaces.Constants.Hook.BSINTERACTIVE<br><br>
    * @param nodeName the name of the node
    * @param hookName the name of the hook
    * @param eventName the name of the event
    * @param hookType the type of the hook
    * @throws HeroException    */
   public void addNodeHook( java.lang.String nodeName,java.lang.String hookName,java.lang.String eventName,int hookType ) throws hero.util.HeroException;

   /**
    * Add/Update a mapper for the INITIATOR role. This type of mapper use a Java file loaded at run time.
    * @param mapperName the name of the mapper
    * @param mapperType the type of the mapper
    * @throws HeroException    */
   public void addInitiatorMapper( java.lang.String mapperName,int mapperType ) throws hero.util.HeroException;

   /**
    * Add/Update an existing mapper to the role. This type of mapper use a Java file loaded at run time.
    * @param roleName the name of the role
    * @param mapperName the name of the mapper
    * @param mapperType the type of the mapper
    * @throws HeroException    */
   public void addRoleMapper( java.lang.String roleName,java.lang.String mapperName,int mapperType ) throws hero.util.HeroException;

   /**
    * Add/Update an existing performerAssign to the node. This type of performerAssign use a Java file loaded at run time.
    * @param nodeName the name of the node
    * @param performerAssignName the name of the performerAssign
    * @param performerAssignType the type of the performerAssign
    * @throws HeroException    */
   public void addNodePerformerAssign( java.lang.String nodeName,java.lang.String performerAssignName,int performerAssignType,java.lang.String propertyName ) throws hero.util.HeroException;

   /**
    * Remove the performer assign defined for this node
    * @param nodeName the name of the node
    * @throws HeroException
    * @throws RemoveException
    * @throws EJBException    */
   public void removeNodePerformerAssign( java.lang.String nodeName ) throws hero.util.HeroException, javax.ejb.EJBException, javax.ejb.RemoveException;

   /**
    * Add interhook to a node. Set a new hook to this node by setting the eventName, hookType and script values.<br><br> The possible values of the argumets are:<br><br> <strong>eventName:<br></strong> hero.interfaces.Constants.Nd.BEFORESTART<br> hero.interfaces.Constants.Nd.AFTERSTART<br> hero.interfaces.Constants.Nd.BEFORETERMINATE<br> hero.interfaces.Constants.Nd.AFTERTERMINATE<br> hero.interfaces.Constants.Nd.ONCANCEL<br> hero.interfaces.Constants.Nd.ANTICIPATE<br><br> hero.interfaces.Constants.Nd.ONDEADLINE<br><br> hero.interfaces.Constants.Nd.ONREADY<br><br> <strong>hookType:<br></strong> hero.hook.Hook.BSINTERACTIVE<br><br> <strong>script:<br></strong> The beanshell source code associated to this hook.<br><br> <strong>The following sample code illustrates how to use this method:<br><br></strong> ...<br> String script = "import hero.interfaces.*;\n"<br> + "import hero.interfaces.BnNodeLocal;\n"<br> + "beforeStart (Object b,Object n) {\n\n\n"<br> + "System.out.println(\"Hook Test\");\n"<br> + "}";<br> <strong>yourProjectSessionInstance</strong>.addNodeInterHook("NodeName","Hook_Name",Constants.Nd.BEFORESTART,hero.hook.Hook.BSINTERACTIVE,script);
    * @param nodeName the name of the node
    * @param hookName the name of the hook
    * @param eventName the name of the event
    * @param hookType the type of the hook
    * @param script the value of the script
    * @throws HeroException    */
   public void addNodeInterHook( java.lang.String nodeName,java.lang.String hookName,java.lang.String eventName,int hookType,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Add interhook to the project. Creates new hook associated to all project activites. See the {@link #addNodeInterHook(String,String,String,int,String) addNodeInterHook} method in order to identify arguments values.
    * @param hookName the name of the hook
    * @param eventName the name of the event
    * @param hookType the type of the hook
    * @param script the value of the script
    * @throws HeroException    */
   public void addInterHook( java.lang.String hookName,java.lang.String eventName,int hookType,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Active a workflow process (model/cooperative)
    * @param name the name of the workflow process
    * @throws HeroException    */
   public void activeProcess(  ) throws hero.util.HeroException;

   /**
    * Hide a workflow process (model/cooperative). This method also clean the associated cache to this model.
    * @param name the name of the workflow process
    * @throws HeroException    */
   public void hideProcess(  ) throws hero.util.HeroException;

   /**
    * Undeploy a workflow process (model/cooperative). This method does not clean the associated cache to this model.
    * @param name the name of the workflow process
    * @throws HeroException    */
   public void unDeployProcess(  ) throws hero.util.HeroException;

   /**
    * Delete a node from the project. If this node is in executing state, the method throws an execption
    * @param name the name of the edge
    * @throws HeroException    */
   public void deleteNode( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Delete a node with type subProcess from the project. If this node is in executing state, the method throws an execption
    * @param name the name of the edge
    * @throws HeroException    */
   public void deleteSubProcessNode( java.lang.String name,java.lang.String version ) throws hero.util.HeroException;

   /**
    * Delete an edge to the project. If out node of this edge is in executing, terminated or cancelled state, the method throws an execption.
    * @param name the name ot the edge
    * @throws HeroException    */
   public void deleteEdge( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Detete a hook. Delete a Java or aTCL hook of this project. </strong>
    * @param hookName the name of the hook
    * @throws HeroException    */
   public void deleteHook( java.lang.String hookName ) throws hero.util.HeroException;

   /**
    * Delete a node hook. Delete a Java or a TCL hook of this node. </strong>
    * @param nodeName the name of the node
    * @param hookName the name
    * @throws HeroException    */
   public void deleteNodeHook( java.lang.String nodeName,java.lang.String hookName ) throws hero.util.HeroException;

   /**
    * Delete a node interHook.
    * @param nodeName the name of the node
    * @param hookName the name of the interHook
    * @throws HeroException    */
   public void deleteNodeInterHook( java.lang.String nodeName,java.lang.String interHookName ) throws hero.util.HeroException;

   /**
    * Detete a interHook of this project. This method deletes this hook from all projects nodes.
    * @param hookName the name of the hook
    * @throws HeroException    */
   public void deleteInterHook( java.lang.String interHookName ) throws hero.util.HeroException;

   /**
    * Delete a role mapper.
    * @param roleName the name of the node
    * @param roleName name
    * @throws HeroException    */
   public void deleteRoleMapper( java.lang.String roleName ) throws hero.util.HeroException;

   /**
    * Delete a role (and the Role mapper if it exists).
    * @param roleName the name of the node
    * @param roleName name
    * @throws HeroException    */
   public void deleteRole( java.lang.String roleName ) throws hero.util.HeroException;

   /**
    * Delete a property of the project. Deletes the project property associated to this key.
    * @param key the key of the property
    * @throws HeroException    */
   public void deleteProperty( java.lang.String key ) throws hero.util.HeroException;

   /**
    * Delete a property of a node. Deletes the node property associated to this key
    * @param nodeName the name of the node
    * @param key the key of the property
    * @throws HeroException    */
   public void deleteNodeProperty( java.lang.String nodeName,java.lang.String key ) throws hero.util.HeroException;

   /**
    * Set a trace level of the actual project.
    * @param level the trace level
    * @throws HeroException    */
   public void setTraceLevel( java.lang.String level ) throws hero.util.HeroException;

   /**
    * Set a log level of the actual project.
    * @param level the log level
    * @throws HeroException    */
   public void setLogLevel( java.lang.String level ) throws hero.util.HeroException;

   /**
    * Set a role to this user. This role is assigned to the user in the context of the actual project.
    * @param userName the name of the user
    * @param roleName the name of the role
    * @throws HeroException    */
   public void setUserRole( java.lang.String userName,java.lang.String roleName ) throws hero.util.HeroException;

   /**
    * Sets the role of an activity. Changes the role of this activity
    * @param name the name of the activity
    * @param role the name of the role
    * @throws HeroException    */
   public void setNodeRole( java.lang.String name,java.lang.String role ) throws hero.util.HeroException;

   /**
    * Set edit node changes. Only for GraphEditor client
    * @param name of the node
    * @param role of the node
    * @param description of the node
    * @param deadline of the node
    */
   public void setEditNode( java.lang.String node,java.lang.String role,java.lang.String description,long deadline ) throws hero.util.HeroException;

   /**
    * Set the edge condition. This condition is evaluated at run-time in order to perform activity transition. To set the condition you have to use beanshell language (Lightweight Scripting for Java).<br> <strong>The next line illustrates the use of setEdgeCondition method:<br><br></strong> ...<br> String condition = "partial_status.equals(\"ok\")";<br> <strong>yourProjectSessionInstance</strong>.setEdgeCondition("edgeName",condition);<br><br> The engine evaluates on the fly the condition by using the If statement. In the previous sample, if the value of the property "partial_status" is equals to "ok" the result of this condition is true.
    * @param edge edge name
    * @param condition condition of the edge
    * @throws HeroException    */
   public void setEdgeCondition( java.lang.String edge,java.lang.String condition ) throws hero.util.HeroException;

   /**
    * Set the node deadline. Activity deadline is the lastest date in which the activity must be finished.
    * @param name the name of the node
    * @param date date of the deadline
    * @throws HeroException
    * @deprecated replaced by setDeadlines(String name, Collection co)    */
   public void setNodeDeadline( java.lang.String name,long date ) throws hero.util.HeroException;

   /**
    * Set a collection of deadlines for the node. Activity deadline is the lastest date in which the activity must be finished.
    * @param name the name of the node
    * @param co collection of dates of the deadline
    * @throws HeroException    */
   public void setNodeDeadlines( java.lang.String name,java.util.Collection co ) throws hero.util.HeroException;

   /**
    * Set a collection of relativeDeadlines for the node.
    * @param name the name of the node
    * @param co collection of dates of the deadline
    * @throws HeroException    */
   public void setNodeRelativeDeadlines( java.lang.String name,java.util.Collection co ) throws hero.util.HeroException;

   /**
    * Set the node relative deadline. Activity deadline is the lastest date in which the activity must be finished.
    * @param name the name of the node
    * @param date date of the deadline
    * @throws HeroException
    * @deprecated replaced by setRelativeDeadlines(String name, Collection co)    */
   public void setNodeRelativeDeadline( java.lang.String name,long date ) throws hero.util.HeroException;

   /**
    * Set the node description. Node description represents, explicity, execution related information of this task.
    * @param name the name of the node
    * @param descriptio description of the node
    * @throws HeroException    */
   public void setNodeDescription( java.lang.String name,java.lang.String description ) throws hero.util.HeroException;

   /**
    * Set the node hook value.
    * @param name name of the node
    * @param hook hookName of the node
    * @param value new script value of this hook
    * @throws HeroException    */
   public void setNodeInterHookValue( java.lang.String node,java.lang.String hook,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Set the hook value. This value is the new hook script associated to all project nodes
    * @param hook hookName of the node
    * @param value new script value of this hook
    * @throws HeroException    */
   public void setInterHookValue( java.lang.String hook,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Unset a user role in this project.
    * @param userName name of the user
    * @param roleName name of the role
    * @throws HeroException    */
   public void unsetUserRole( java.lang.String userName,java.lang.String roleName ) throws hero.util.HeroException;

   /**
    * Unset a user for this project
    * @param userName The name of the user
    * @throws HeroException    */
   public void unsetUser( java.lang.String userName ) throws hero.util.HeroException;

   /**
    * Set the node in traditional mode. When a node is traditional the anticipable attribute is false. This method must be used if you want to execute this activity in a traditional model.
    * @param name name of the node
    * @throws HeroException    */
   public void setNodeTraditional( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Set the node in anticipable mode.
    * @param name the name of the node
    * @throws HeroException    */
   public void setNodeAnticipable( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Set the node in automatic mode. The responsible of the activity execution is now the engine.
    * @param name the name of the node
    * @throws HeroException
    * @deprecated replaced by setNodeType    */
   public void setNodeAutomatic( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Set the node type. Change the current type of the node (if node is not executing).<br><br> Possibles node types are:<br> hero.interfaces.Constants.Nd.AND_JOIN_NODE<br> hero.interfaces.Constants.Nd.OR_JOIN_NODE<br> hero.interfaces.Constants.Nd.AND_JOIN_AUTOMATIC_NODE<br> hero.interfaces.Constants.Nd.OR_JOIN_AUTOMATIC_NODE<br>
    * @param name the name of the node
    * @throws HeroException    */
   public void setNodeType( java.lang.String name,int type ) throws hero.util.HeroException;

   /**
    * Set a property of a node. A property is a pair key/value representing workflow relevant data. By using propagate argument we can specify if we want to propagate this property.
    * @param nodeName the name of the node
    * @param key the key of the property
    * @param value the name of the property
    * @param propagate if it is a propagation property
    * @throws HeroException    */
   public void setNodeProperty( java.lang.String nodeName,java.lang.String key,java.lang.String value,boolean propagate ) throws hero.util.HeroException;

   /**
    * Set a property of a node. A property is a pair key/value representing workflow relevant data. With this method the property is propagated within others nodes.
    * @param nodeName the name of the node
    * @param key the key of the property
    * @param value the name of the property
    * @throws HeroException    */
   public void setNodeProperty( java.lang.String nodeName,java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Set a property of the project. A property is a pair key/value representing workflow relevant data. This methods creates a new property that can be accessed from all activites of the project.
    * @param key the key of the property
    * @param value the name of the property
    * @throws HeroException    */
   public void setProperty( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Set property possible values for a specific node. Values argument represent the values which are accepted as possible property values.
    * @param nodeName the name of the node
    * @param key property key
    * @param values possible values
    * @throws HeroException    */
   public void setNodePropertyPossibleValues( java.lang.String nodeName,java.lang.String key,java.util.Collection values ) throws hero.util.HeroException;

   /**
    * This method allows users to change dynamically the possible values defined for this property. Only used for enumeration types. A default value is mandatory for this method.
    * @param nodeName the name of the node
    * @param key property key
    * @param values possible values
    * @param defaultValues Collection of default values
    * @throws HeroException    */
   public void updateNodePropertyPossibleValues( java.lang.String nodeName,java.lang.String key,java.util.Collection values,java.util.Collection defaultValues ) throws hero.util.HeroException;

   /**
    * Set property possible values. Values argument represent the values which are accepted as possible property values.
    * @param key property key
    * @param values possible values
    * @throws HeroException    */
   public void setPropertyPossibleValues( java.lang.String key,java.util.Collection values ) throws hero.util.HeroException;

   /**
    * This method allows users to change dynamically the possible values defined for this property. Only used for enumeration types. A default value is mandatory for this method.
    * @param key property key
    * @param values possible values
    * @param defaultValues Collection of default values
    * @throws HeroException    */
   public void updatePropertyPossibleValues( java.lang.String key,java.util.Collection values,java.util.Collection defaultValues ) throws hero.util.HeroException;

   /**
    * Execute a node hook.
    * @param nodeName the name of the node
    * @param event the event
    * @throws HeroException    */
   public void hookEvent( java.lang.String nodeName,java.lang.String event ) throws hero.util.HeroException;

   /**
    * Propagate node properties. Propagates all node properties to connected nodes.
    * @param nodeName the name of the Node
    * @throws HeroException    */
   public void propagateNodeProperties( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Set the node state. Set start date of this node when starts the execution and the end date when node is terminated.
    * @param name name of the node
    * @param state new state of the node
    * @throws HeroException    */
   public void setNodeState( hero.interfaces.BnNodeLocal node,int state ) throws hero.util.HeroException;

   /**
    * Set all initial roles to ready if node does not has in edges.
    * @throws HeroException    */
   public void setNodesReady(  ) throws hero.util.HeroException;

   /**
    * Propagate subProcess activity properties to subProcess
    * @param node the name of the node
    * @throws HeroException    */
   public void propagatesParentProperties( java.lang.String node ) throws hero.util.HeroException;

   /**
    * Propagate subProcess properties to subProcess activity.
    * @param node the name of the node
    * @throws HeroException    */
   public void propagatesSubProcessProperties( hero.interfaces.BnNodeLocal node ) throws hero.util.HeroException;

   /**
    * Set the edge state
    * @param bean of the edge
    * @param new state of the edge
    * @throws HeroException    */
   public void setEdgeState( hero.interfaces.BnEdgeLocal edge,int state ) throws hero.util.HeroException;

   /**
    * Set the agent state
    * @param agent bean of the Agent
    * @param new state of the Agent
    * @throws HeroException    */
   public void setAgentState( hero.interfaces.BnAgentLocal agent,int state ) throws hero.util.HeroException;

   /**
    * Set the agentEdge state
    * @param agentEdge bean of the BnAgentEdge
    * @param new state of the BnAgentEdge
    * @throws HeroException    */
   public void setAgentEdgeState( hero.interfaces.BnAgentEdgeLocal agentEdge,int state ) throws hero.util.HeroException;

   /**
    * Set the name of the node executor. Set the name of the user which is executing the activity.
    * @param name the name of the node
    * @throws HeroException    */
   public void setNodeExecutor( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the list of choices into the value of the enumerated property .
    * @param value the value of the enumerated property
    * @param possiblesValues collection of the enumerated property
    * @return Collection of choices of the enumerated property into the value
    * @throws HeroException    */
   public java.util.ArrayList getChoices( java.lang.String value,java.util.Collection possibleValues ) throws hero.util.HeroException;

   /**
    * Get the node description. Node description represents, explicity, execution related information of this task.
    * @param name of the node
    * @return String - description of the node
    * @throws HeroException    */
   public java.lang.String getNodeDescription( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the node hook value. This method returns the hook script associated to this node
    * @param name the name of the node
    * @param hook hookName of the node
    * @return String - script associated to this hook
    * @throws HeroException    */
   public java.lang.String getNodeInterHookValue( java.lang.String node,java.lang.String hook ) throws hero.util.HeroException;

   /**
    * Get the inter hook value script. This method returns the hook script associated to all project nodes.
    * @param hook hook name
    * @return String - script associated to this hook
    * @throws HeroException    */
   public java.lang.String getInterHookValue( java.lang.String hook ) throws hero.util.HeroException;

   /**
    * Get the ProjectValue (historique). Returns project information: project attributes, nodes, edges, hooks, properties...
    * @return BnProjectValue object - project data
    * @throws HeroException    */
   public hero.interfaces.BnProjectValue getDetails(  ) throws hero.util.HeroException;

   /**
    * Get the ProjectLightValue. Returns the basic project information: project attributes (without relationships)
    * @return BnProjectLightValue object - project data
    * @throws HeroException    */
   public hero.interfaces.BnProjectLightValue getLightDetails(  ) throws hero.util.HeroException;

   /**
    * Get ProjectName
    * @return String - project name
    * @throws HeroException    */
   public java.lang.String getName(  ) throws hero.util.HeroException;

   /**
    * Get ProjectVersion
    * @return String - project version
    * @throws HeroException    */
   public java.lang.String getVersion(  ) throws hero.util.HeroException;

   /**
    * Get creator of the project. The user that created the project
    * @return String - project creator
    * @throws HeroException    */
   public java.lang.String getCreator(  ) throws hero.util.HeroException;

   /**
    * Get status of the project. Active/Hidden
    * @return String - project status
    * @throws HeroException    */
   public java.lang.String getStatus(  ) throws hero.util.HeroException;

   /**
    * Get type of the project. Cooperative/Model/Instance
    * @return String - project type
    * @throws HeroException    */
   public java.lang.String getType(  ) throws hero.util.HeroException;

   /**
    * Get all roles of the project
    * @return Collection of BnRoleLocal objects - roles of the project
    * @throws HeroException    */
   public java.util.Collection getRoles(  ) throws hero.util.HeroException;

   /**
    * Get all roles values of the project
    * @return Collection of BnRoleValue objects - roles of the project
    * @throws HeroException    */
   public java.util.Collection getRolesValue(  ) throws hero.util.HeroException;

   /**
    * Get the value of this role in the project
    * @return BnRoleValue - role of the project
    * @throws HeroException    */
   public hero.interfaces.BnRoleValue getRoleValue( java.lang.String roleName ) throws hero.util.HeroException;

   /**
    * Get performer assign of this node.
    * @return BnNodePerformerAssignValue of this node
    * @param nodeName the name of the node
    * @throws HeroException    */
   public hero.interfaces.BnNodePerformerAssignValue getNodePerformerAssign( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get all roles names of the project
    * @return String Collection - roles names of this projects
    * @throws HeroException    */
   public java.util.Collection getRolesNames(  ) throws hero.util.HeroException;

   /**
    * Get all user roles. This method returns all the roles for this user in differents projects.
    * @param userName The name of the user
    * @return Collection of BnRoleValue objects - roles of the user in differents projects
    * @throws HeroException    */
   public java.util.Collection getUserRoles( java.lang.String userName ) throws hero.util.HeroException;

   /**
    * Get user roles in the current project. Returns the roles of this user in the current project.
    * @param userName The name of the user
    * @return Collection of BnRoleValue objects - roles of the user in this project
    * @throws HeroException    */
   public java.util.Collection getUserRolesInProject( java.lang.String userName ) throws hero.util.HeroException;

   /**
    * Get users matching with given role in the current project.
    * @param roleName The name of the role
    * @return Collection of String - users matching with this role
    * @throws HeroException    */
   public java.util.Collection getUsersRole( java.lang.String roleName ) throws hero.util.HeroException;

   /**
    * Get user roles in project names. Returns the role names of the user in the current project
    * @param userName The name of the user
    * @return String Collection - role names of this user in the current project
    * @throws HeroException    */
   public java.util.Collection getUserRolesInProjectNames( java.lang.String userName ) throws hero.util.HeroException;

   /**
    * Get node role. Returns the role information.
    * @param nodeName The name of the node
    * @return BnRoleLocal object - the role data
    * @throws HeroException    */
   public hero.interfaces.BnRoleLocal getNodeRole( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get the edge Condition. This condition is evaluated at run-time in order to perform activity transition. This condition follows the beanshell syntax (Lightweight Scripting for Java).<br>
    * @param edge the edge/transition name
    * @return String - edge condition
    * @throws HeroException    */
   public java.lang.String getEdgeCondition( java.lang.String edge ) throws hero.util.HeroException;

   /**
    * Returns if the node is set to be executed in anticipated mode.
    * @param name name of the node
    * @return boolean - if anticipable node is set to this node.
    * @throws HeroException    */
   public boolean getNodeAnticipable( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get node role name. Obtains the role name of this node.
    * @param nodeName The name of the node
    * @return String - the role name of this node
    * @throws HeroException    */
   public java.lang.String getNodeRoleName( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get node deadline. Activity deadline is the lastest date in which the activity must be finished.
    * @param nodeName The name of the node
    * @return String - deadline of this node
    * @throws HeroException
    * @deprecated replaced by getNodeDeadlines(String name, Collection co)    */
   public java.lang.String getNodeDeadline( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get collection of absolute deadlines for the node. Activity deadline is the lastest date in which the activity must be finished.
    * @param nodeName The name of the node
    * @return Collection - collection of deadlines of this node
    * @throws HeroException    */
   public java.util.Collection getNodeDeadlines( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get collection of relative deadlines for the node. Activity deadline is the lastest date in which the activity must be finished.
    * @param nodeName The name of the node
    * @return Collection - collection of deadlines of this node
    * @throws HeroException    */
   public java.util.Collection getNodeRelativeDeadlines( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get the node Value. Returns node information.
    * @param name the name of the Node
    * @return BnNodeValue object - node data.
    * @throws HeroException    */
   public hero.interfaces.BnNodeValue getNodeValue( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the Agent Value.
    * @param name the name of the Agent
    * @return BnAgentValue object - agent data.
    * @throws HeroException    */
   public hero.interfaces.BnAgentValue getAgentValue( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the AgentEdge Value
    * @param name the name of the BnAgentEdge
    * @return BnAgentEdgeValue object - agentEdge data.
    * @throws HeroException    */
   public hero.interfaces.BnAgentEdgeValue getAgentEdgeValue( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the node Light Value. Returns node basic information.
    * @param name the name of the Node
    * @return BnNodeLightValue object - agentEdge data.
    * @throws HeroException    */
   public hero.interfaces.BnNodeLightValue getNodeLightValue( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the edge value.
    * @param name the name of the edge
    * @return BnEdgeValue object - edge data.
    * @throws HeroException    */
   public hero.interfaces.BnEdgeValue getEdgeValue( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the node executor. Get the name of the user which is executing the activity.
    * @param name the name of the node
    * @return String - the user executor of this node
    * @throws HeroException    */
   public java.lang.String getNodeExecutor( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the state of the node. The possible states for a node are:<br><br> hero.interfaces.Constants.Nd.INITIAL<br> hero.interfaces.Constants.Nd.READY<br> hero.interfaces.Constants.Nd.DEAD<br> hero.interfaces.Constants.Nd.ANTICIPABLE<br> hero.interfaces.Constants.Nd.ANTICIPATING<br> hero.interfaces.Constants.Nd.EXECUTING<br> hero.interfaces.Constants.Nd.TERMINATED<br>
    * @param name of the node
    * @return int - The state of the node
    * @throws HeroException    */
   public int getNodeState( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get the type of the node. Possibles node types are:<br><br> hero.interfaces.Constants.Nd.AND_JOIN_NODE<br> hero.interfaces.Constants.Nd.OR_JOIN_NODE<br> hero.interfaces.Constants.Nd.AND_JOIN_AUTOMATIC_NODE<br> hero.interfaces.Constants.Nd.OR_JOIN_AUTOMATIC_NODE<br>
    * @param name of the node
    * @return int - The type of the node
    * @throws HeroException    */
   public int getNodeType( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get all users of the project. Obtains the user names of the project
    * @return String Collection - user names in project
    * @throws HeroException    */
   public java.util.Collection getUsers(  ) throws hero.util.HeroException;

   /**
    * Return all registered users. Get user names of Bonita System
    * @return String Collection - all user names
    * @throws HeroException    */
   public java.util.Collection getAllUsers(  ) throws hero.util.HeroException;

   /**
    * Get all node names of the project
    * @return String Collection - all node names
    * @throws HeroException    */
   public java.util.Collection getNodesNames(  ) throws hero.util.HeroException;

   /**
    * Get all edges names of the project
    * @return String Collection - all edges names of the project
    * @throws HeroException    */
   public java.util.Collection getEdgesNames(  ) throws hero.util.HeroException;

   /**
    * Get edge in node. Returns the name of in node
    * @param edgeName the name ot the edge
    * @return String - the name of in node
    * @throws HeroException    */
   public java.lang.String getEdgeInNode( java.lang.String edgeName ) throws hero.util.HeroException;

   /**
    * Get edge out node. Returns the name of out node
    * @param edgeName the name ot the edge
    * @return String - the name of out node
    * @throws HeroException    */
   public java.lang.String getEdgeOutNode( java.lang.String edgeName ) throws hero.util.HeroException;

   /**
    * Get all in edges of the node
    * @param name the name ot the node
    * @return String Collection - get in edges of the node
    * @throws HeroException    */
   public java.util.Collection getNodeInEdges( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get all out edges of the node
    * @param name the name ot the node
    * @return String Collection - get out edges of the node
    * @throws HeroException    */
   public java.util.Collection getNodeOutEdges( java.lang.String name ) throws hero.util.HeroException;

   /**
    * Get Node properties. Get a list of pair key/value properties associated to the node.
    * @param nodeName the name of the node
    * @return Collection of BnNodePropertyValue objects - all node properties
    * @throws HeroException    */
   public java.util.Collection getNodeProperties( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get Node property value. Get a pair key/value properties associated to the node.
    * @param nodeName the name of the node
    * @param key Property key
    * @return BnNodePropertyValue object - node property data
    * @throws HeroException    */
   public hero.interfaces.BnNodePropertyValue getNodeProperty( java.lang.String nodeName,java.lang.String key ) throws hero.util.HeroException;

   /**
    * Get property value of the project. Get a pair key/value properties associated to this project.
    * @param key Property key
    * @return BnProjectPropertyValue object - property data
    * @throws HeroException    */
   public hero.interfaces.BnProjectPropertyValue getProperty( java.lang.String key ) throws hero.util.HeroException;

   /**
    * Get Node hooks of the project. Get hooks of the node. Method to get the list of Java or TCL hooks of the node.
    * @param nodeName the name of the node
    * @return Collection of BnNodeHookValue - all node hooks
    * @throws HeroException    */
   public java.util.Collection getNodeHooks( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get Interactive Node hooks of the project
    * @param nodeName the name of the node
    * @return Collection of BnNodeInterHookValue objects - all node hooks
    * @throws HeroException    */
   public java.util.Collection getNodeInterHooks( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get role mappers of the project.
    * @return Collection of BnRoleMapperValue - all role mappers
    * @throws HeroException    */
   public java.util.Collection getRoleMappers(  ) throws hero.util.HeroException;

   /**
    * Get Interactive hooks of the project. Returns hooks assigned to project nodes.
    * @return Collection of ProjectInterHookValue - project inter hooks
    * @throws HeroException    */
   public java.util.Collection getInterHooks(  ) throws hero.util.HeroException;

   /**
    * Get Node inter hook of the project
    * @param nodeName the name of the node
    * @param interHook name of the hooks
    * @return BnNodeInterHookValue object - node hook data
    * @throws HeroException    */
   public hero.interfaces.BnNodeInterHookValue getNodeInterHook( java.lang.String nodeName,java.lang.String interHook ) throws hero.util.HeroException;

   /**
    * Get properties key of the project. A property is a pair key/value representing workflow relevant data. This methods obtains properties key of the project.
    * @return Collection of String - all project properties
    * @throws HeroException    */
   public java.util.Collection getPropertiesKey(  ) throws hero.util.HeroException;

   /**
    * Get ALL project iterations.
    * @return Collection of BnIterationLightValue - all project iterations
    * @throws HeroException    */
   public java.lang.Object[] getIterations(  ) throws hero.util.HeroException;

   /**
    * Get nodes destinations of this iteration. <br> We can have more than 1 iteration starting in the same node.
    * @return Collection
    * @throws HeroException    */
   public java.util.Collection getIterations( java.lang.String from ) throws hero.util.HeroException;

   /**
    * Verifies if this node starts one iteration or more iterations
    * @return boolean
    * @throws HeroException    */
   public boolean getIterationExist( java.lang.String from ) throws hero.util.HeroException;

   /**
    * Verifies if an iteration exist between both nodes
    * @return boolean
    * @throws HeroException    */
   public boolean getIterationExist( java.lang.String from,java.lang.String to ) throws hero.util.HeroException;

   /**
    * Get iterations conditions <br> We can have more than 1 iteration starting in the same node.
    * @return Collection - collection of conditions that starts in node from
    * @throws HeroException    */
   public java.util.Collection getIterationConditions( java.lang.String from ) throws hero.util.HeroException;

   /**
    * Get properties of the project. A property is a pair key/value representing workflow relevant data. This method obtains properties of the project.
    * @return Collection of ProjectPropertyValue - all project properties
    * @throws HeroException    */
   public java.util.Collection getProperties(  ) throws hero.util.HeroException;

   /**
    * Get hooks of the project. Method to get the list of Java or TCL hooks of the project
    * @return Collection of BnProjectHooksValue - all project hook
    * @throws HeroException    */
   public java.util.Collection getHooks(  ) throws hero.util.HeroException;

   /**
    * Get the project name of this instance
    * @param instanceName the name of the instance
    * @return String - the project name
    * @throws HeroException    */
   public java.lang.String getProjectNameOfInstance( java.lang.String instanceName ) throws hero.util.HeroException;

   /**
    * Get the parent project of this project
    * @return String - the parent project of this project
    * @throws HeroException    */
   public java.lang.String getParent(  ) throws hero.util.HeroException;

   /**
    * Test if projects nodes are terminated
    * @return boolean - the result of the test
    * @throws HeroException    */
   public boolean isTerminated(  ) ;

   /**
    * Get the StrutsNode. Returns node information with a specific java bean structure (useful in struts web applications).
    * @param nodeName the name of the Node
    * @return BnStrutsNodeValue object - node data.
    * @throws HeroException    */
   public hero.util.StrutsNodeValue getStrutsNode( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get the project nodes. Returns project nodes data.
    * @return Array of StrutsNodeValue - all project nodes
    * @throws HeroException    */
   public java.lang.Object[] getNodes(  ) throws hero.util.HeroException;

   /**
    * Get the StrutsNodes. Returns nodes information with a specific java bean structure (useful in struts web applications).
    * @return Collection of StrutsNodeValue - all project nodes
    * @throws HeroException    */
   public java.util.Collection getStrutsNodes(  ) throws hero.util.HeroException;

   /**
    * Get the Edges of the Node. Returns node edges information with a specific java bean structure (useful in struts web applications).
    * @param nodeName the name of the Node
    * @return Collection of StrutsEdgeValue - all node edges
    * @throws HeroException    */
   public java.util.Collection getStrutsNodeEdges( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get the StrutsEdges. Returns project edges information with a specific java bean structure (useful in struts web applications).
    * @return Collection of StrutsEdgeValue - all project edges
    * @throws HeroException    */
   public java.util.Collection getStrutsEdges(  ) throws hero.util.HeroException;

   /**
    * Import all the nodes, hooks and edges of a project to the current project
    * @param projectname the name of the project
    * @throws HeroException    */
   public void importProject( java.lang.String projectName,java.lang.String projectVersion ) throws hero.util.HeroException;

   /**
    * Import all the nodes, hooks, properties and edges of a project to the current project
    * @param projectname the name of the project
    * @param prefix the prefix of names for the project
    * @throws HeroException    */
   public void importProject( java.lang.String projectName,java.lang.String projectVersion,java.lang.String prefix ) throws hero.util.HeroException;

   /**
    * Import Project instance. Import all the nodes, hooks, properties,edges and users of a project instant to the current project
    * @param projectname the name of the project
    * @param instance the instance name of the project
    * @throws HeroException    */
   public java.lang.String importInstance( hero.util.values.BonitaProjectValue pv,java.lang.String instance,java.lang.String version,java.util.Hashtable initProperties,boolean subProcess ) throws hero.util.HeroException;

   /**
    * Test if the project with projectName name exists.
    * @param projectName project name
    * @throws HeroException    */
   public boolean existingProject( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Test if the project with projectName and projectVersion name exists.
    * @param projectName project name
    * @param projectName project name
    * @throws HeroException    */
   public boolean existingProject( java.lang.String projectName,java.lang.String projectVersion ) throws hero.util.HeroException;

   /**
    * Creates a cooperative workflow or creates a pointer to the Project Session Bean for this cooperative/instance element. You have to call this method after "create" call. After that all methods of ProjectSession API are available.
    * @param projectName project name
    * @throws HeroException    */
   public void initProject( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Executes the OnInstatiate hook associated to this process. This method can only be called before a workflow model is instantiated.
    * @throws HeroException    */
   public void executeProcessHook(  ) throws hero.util.HeroException;

   /**
    * Creates a workflow process model or Init the Project Session Bean for this model. You have to call this method after "create" call. After that all methods of ProjectSession API are available.
    * @param modelName model name
    * @throws HeroException    */
   public void initModel( java.lang.String modelName ) throws hero.util.HeroException;

   /**
    * Creates a workflow process model or Init the Project Session Bean for this model. You have to call this method after "create" call. After that all methods of ProjectSession API are available.
    * @param modelName model name
    * @param modelVersion model version
    * @throws HeroException    */
   public void initModelWithVersion( java.lang.String modelName,java.lang.String modelVersion ) throws hero.util.HeroException;

   /**
    * init the Project Session Bean (clone project).You have to call this method after "create" call. After that the project is cloned and all methods of ProjectSession API are available.
    * @throws HeroException
    * @param oldProject the name of the project to clone
    * @param newProject the name of the project clone.
    * @throws CreateException    */
   public void initProject( java.lang.String oldProject,java.lang.String newProject ) throws javax.ejb.CreateException;

   /**
    * init the Project Session Bean (clone project).You have to call this method after "create" call. After that the project is cloned and all methods of ProjectSession API are available.
    * @throws HeroException
    * @param oldProject the name of the project to clone
    * @param oldVersion the version of the project to clone
    * @param newProject the name of the project clone.
    * @throws CreateException    */
   public void initProjectWithVersion( java.lang.String oldProject,java.lang.String oldVersion,java.lang.String newProject ) throws javax.ejb.CreateException;

   /**
    * Project instance. You have to call this method after "create" call. After that you have an instance of the project and all methods of ProjectSession API are available.
    * @param project the name of the project to instance
    * @return String - the name of the project instance
    * @return Hashtable - default value for properties defined at process level
    * @throws CreateException    */
   public java.lang.String instantiateProject( java.lang.String project,java.util.Hashtable initProperties ) throws javax.ejb.CreateException;

   /**
    * Project instance. You have to call this method after "create" call. After that you have an instance of the project and all methods of ProjectSession API are available.
    * @param project the name of the project to instance
    * @param version the version of the project to instance
    * @return String - the name of the project instance
    * @return Hashtable - default value for properties defined at process level
    * @throws CreateException    */
   public java.lang.String instantiateProject( java.lang.String project,java.lang.String version,java.util.Hashtable initProperties ) throws javax.ejb.CreateException;

   /**
    * Project instance. You have to call this method after "create" call. After that you have an instance of the project and all methods of ProjectSession API are available.
    * @param project the name of the project to instance
    * @return String - the name of the project instance
    * @throws CreateException    */
   public java.lang.String instantiateProject( java.lang.String project ) throws javax.ejb.CreateException;

   /**
    * Project instance. You have to call this method after "create" call. After that you have an instance of the project and all methods of ProjectSession API are available.
    * @param project the name of the project to instance
    * @param version the version of the project to instance
    * @return String - the name of the project instance
    * @throws CreateException    */
   public java.lang.String instantiateProject( java.lang.String project,java.lang.String version ) throws javax.ejb.CreateException;

   /**
    * Project instance. Process instantiation without default execution of automatic activities (for subprocesses)
    * @param project the name of the project to instance
    * @param version the version of the project to instance
    * @return String - the name of the project instance
    * @throws CreateException    */
   public java.lang.String instantiateProjectSubProcess( java.lang.String project,java.lang.String version ) throws javax.ejb.CreateException;

   /**
    * Returns whether the user belongs to the activity role
    * @param nodeName the name of the node
    * @throws CreateException    */
   public boolean isUserInNodeRole( java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Copy node. Internal method used in processes instantiation.
    * @param name of the new node
    * @param node the BnNodeLocal object of the copied node.
    * @param inNode the BnNodeLocal in node object of the new node.
    */
   public void copyNode( java.lang.String nodeName,hero.util.values.BonitaNodeValue node ) throws hero.util.HeroException;

   /**
    * Copy node edge. Internal method used in processes instantiation.
    * @param name of the new node
    * @param inNode the BnNodeLocal in node object of the new node.
    * @param edge the BnEdgeLocal edge object from the project model.
    */
   public void copyEdge( java.lang.String nodeName,hero.interfaces.BnNodeLocal inNode,hero.util.values.BonitaEdgeValue edge ) throws hero.util.HeroException;

   /**
    * Test if the project contains this user
    * @param userName The name of the user to associate to the project
    * @return boolean - true is the user belongs to the project
    * @throws HeroException    */
   public boolean containsUser( java.lang.String userName ) throws hero.util.HeroException;

   /**
    * Local method
    * @throws HeroException    */
   public java.lang.String getCaller(  ) ;

   /**
    * Local method
    * @throws HeroException    */
   public void setCaller( java.lang.String user ) ;

   /**
    * Checks if the project model is correctly defined.
    * @throws HeroException    */
   public void checkModelDefinition(  ) throws hero.util.HeroException;

}
