package action.email;

import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.BodyPart;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

public class MailClient {


  public static void send(Properties mailProps) {
	 String mailServer = mailProps.getProperty("mail.smtp.host");
	 String subject  =   mailProps.getProperty("mail.subject");
	 String from =   mailProps.getProperty("mail.from");
	 String to =   mailProps.getProperty("mail.to");
	 String body = 	  mailProps.getProperty("mail.messagepath");
 
	  
	  try {

//        System.out.println("mailServer = " + mailServer);
//        System.out.println("from = " + from);
//        System.out.println("to = " + to);
//        System.out.println("subject = " + subject);
//        System.out.println("body = " + body);
//     	  System.out.println(" get session");
	    Session session = Session.getInstance(mailProps, null);
//      	System.out.println(" got session");
       	MimeMessage m = new MimeMessage(session);
       	m.setFrom(new InternetAddress(from) );
       	//Address[] to = new InternetAddress[] { new InternetAddress(from) };
//       	System.out.println(" set recipients");
      	m.setRecipients(javax.mail.Message.RecipientType.TO, to);
       	m.setSubject(subject);
       	m.setSentDate(new java.util.Date());
       	if (body.length() != 0) 
       	{
//      Create the message attachment 
        	Multipart  multipart = new MimeMultipart();
        	BodyPart messageBodyPart = new MimeBodyPart();
        	DataSource source = new FileDataSource(body);
        	messageBodyPart.setDataHandler(new DataHandler(source));
        	messageBodyPart.setFileName(body);
        	multipart.addBodyPart(messageBodyPart);
       		m.setContent(multipart);
		} 
       	else  
		{
			m.setContent(body,"text/plain");
		}

//       	System.out.println(" ready to send");
       	Transport.send(m);
       	System.out.println("Email sent to: " + to);
   	}
   	catch (Exception e) {
     		System.out.println("mail-service.xml configuration error: " + e);
     		e.printStackTrace();     		
   	}
  }//MailClient
  
  
  public static void main(String[] arg) {
	  
    Properties mailProps = new Properties();
    File propFile = 
    	new File("C:/Workspace/mailClientWrapper/action/email/mail.properties");
    if (propFile.exists()) {

  	  try {
  	  	;
  	  mailProps.load(new FileInputStream(propFile));
  	  } catch (Exception ex){
  	  	ex.printStackTrace();
  	  }   
    }//props found ^^	  
	  send(mailProps);
	  
  }

}//SendMail

